/* Created to ilustrate the use of GLib.
   Copyright (C) 2004 by Claudio Saavedra V. */

/* Compile with:
   gcc -o glist glist.c `pkg-config --cflags --libs glib-2.0`
*/

#include <glib.h>

/* prints a list of numbers */
void
g_list_print (GList *root)
{
	GList *iter;
	for (iter = root; iter != NULL; iter = g_list_next (iter))
		g_print ("%d\n", GPOINTER_TO_INT (iter->data));
}

int
main (gint argc, gchar **argv)
{
	g_return_val_if_fail (argc > 2, 1);
	
	GList *root = NULL;
	gint i, n;

	n = g_strtod (argv[1], NULL);
	g_print ("%d\n", n);

	/* fill the list */
	g_print ("fill...\n");
	for (i = 0; i < n; ++i)
			root = g_list_append (root, GINT_TO_POINTER (i));

	g_list_print (root);

	/* now, let's remove a item */
	g_print ("remove...\n");
	i = g_strtod (argv[2], NULL);
	g_list_remove (root, GINT_TO_POINTER (i));
	g_list_print (root);

	return 0;
}
